Other Classes: Class XML11Serializer

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xml.serialize
Class XML11Serializer

    java.lang.Object
      |
      +--org.apache.xml.serialize.BaseMarkupSerializer
            |
            +--org.apache.xml.serialize.XMLSerializer
                  |
                  +--org.apache.xml.serialize.XML11Serializer

All Implemented Interfaces:
  org.xml.sax.ContentHandler, org.xml.sax.ext.DeclHandler, org.xml.sax.DocumentHandler, DOMSerializer, org.xml.sax.DTDHandler, org.xml.sax.ext.LexicalHandler, Serializer

public class XML11Serializer
extends XMLSerializer

Implements an XML serializer supporting both DOM and SAX pretty serializing. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. SAX serializing is done by firing SAX events and using the serializer as a document handler. DOM serializing is done by calling `BaseMarkupSerializer.serialize(Document)` or by using DOM Level 3 `org.w3c.dom.ls.DOMSerializer` and serializing with `org.w3c.dom.ls.DOMSerializer#write`, `org.w3c.dom.ls.DOMSerializer#writeToString`.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

Version:
  $Revision: 1.8 $ $Date: 2004/01/29 21:11:30 $
Author:
  Assaf Arkin, Rahul Srivastava, Elena Litani IBM
See Also:
  `Serializer`

Field Summary
`protected static boolean` | `DEBUG`
`protected boolean` | `fDOML1`
`protected org.apache.xerces.util.NamespaceSupport` | `fLocalNSBinder` stores all namespace bindings on the current element
`protected int` | `fNamespaceCounter`
`protected boolean` | `fNamespaces` Controls whether namespace fixup should be performed during the serialization.
`protected org.apache.xerces.util.NamespaceSupport` | `fNSBinder` stores namespaces in scope
`protected org.apache.xerces.util.SymbolTable` | `fSymbolTable` symbol table for serialization
`protected static java.lang.String` | `PREFIX`

Fields inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _encodingInfo, _format, _indenting, _prefixes, _printer, _started, fCurrentNode, fDOMError, fDOMErrorHandler, fDOMFilter, features, fStrBuffer`

Constructor Summary
`XML11Serializer()` Constructs a new serializer.
`XML11Serializer(OutputFormat format)` Constructs a new serializer.
`XML11Serializer(java.io.OutputStream output, OutputFormat format)` Constructs a new serializer that writes to the specified output stream using the specified output format.
`XML11Serializer(java.io.Writer writer, OutputFormat format)` Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`void` | `characters(char[] chars, int start, int length)`
`protected void` | `printCDATAText(java.lang.String text)`
`protected void` | `printEscaped(java.lang.String source)` Escapes a string so it may be printed as text content or attribute value.
`protected void` | `printText(char[] chars, int start, int length, boolean preserveSpace, boolean unescaped)` Called to print additional text with whitespace handling.
`protected void` | `printText(java.lang.String text, boolean preserveSpace, boolean unescaped)`
`protected void` | `printXMLChar(int ch)` print text data
`boolean` | `reset()`
`protected void` | `surrogates(int high, int low)`

Methods inherited from class org.apache.xml.serialize.XMLSerializer
`checkUnboundNamespacePrefixedNode, endElement, endElement, endElementIO, getEntityRef, serializeElement, setNamespaces, setOutputFormat, startDocument, startElement, startElement`

Methods inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, characters, comment, comment, content, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, fatalError, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, modifyDOMError, notationDecl, prepare, printDoctypeURL, printEscaped, processingInstruction, processingInstructionIO, serialize, serialize, serialize, serializeNode, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEBUG

    protected static final boolean DEBUG

### fNSBinder

    protected org.apache.xerces.util.NamespaceSupport fNSBinder

  stores namespaces in scope

### fLocalNSBinder

    protected org.apache.xerces.util.NamespaceSupport fLocalNSBinder

  stores all namespace bindings on the current element

### fSymbolTable

    protected org.apache.xerces.util.SymbolTable fSymbolTable

  symbol table for serialization

### fDOML1

    protected boolean fDOML1

### fNamespaceCounter

    protected int fNamespaceCounter

### PREFIX

    protected static final java.lang.String PREFIX

### fNamespaces

    protected boolean fNamespaces

  Controls whether namespace fixup should be performed during the serialization. NOTE: if this field is set to true the following fields need to be initialized: fNSBinder, fLocalNSBinder, fSymbolTable, XMLSymbols.EMPTY_STRING, fXmlSymbol, fXmlnsSymbol, fNamespaceCounter.

Constructor Detail

### XML11Serializer

    public XML11Serializer()

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### XML11Serializer

    public XML11Serializer(OutputFormat format)

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### XML11Serializer

    public XML11Serializer(java.io.Writer writer,
                           OutputFormat format)

  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.
  Parameters:
    `writer` - The writer to use
    `format` - The output format to use, null for the default

### XML11Serializer

    public XML11Serializer(java.io.OutputStream output,
                           OutputFormat format)

  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.
  Parameters:
    `output` - The output stream to use
    `format` - The output format to use, null for the default

Method Detail

### characters

    public void characters(char[] chars,
                           int start,
                           int length)
                    throws org.xml.sax.SAXException

  Overrides:
    `characters` in class `BaseMarkupSerializer`

### printEscaped

    protected void printEscaped(java.lang.String source)
                         throws java.io.IOException

  Description copied from class: `BaseMarkupSerializer`
  Escapes a string so it may be printed as text content or attribute value. Non printable characters are escaped using character references. Where the format specifies a deault entity reference, that reference is used (e.g. `&lt;`).
  Overrides:
    `printEscaped` in class `XMLSerializer`
  Following copied from class: `org.apache.xml.serialize.BaseMarkupSerializer`
  Parameters:
    `source` - The string to escape

### printCDATAText

    protected final void printCDATAText(java.lang.String text)
                                 throws java.io.IOException

  Overrides:
    `printCDATAText` in class `BaseMarkupSerializer`

### printXMLChar

    protected final void printXMLChar(int ch)
                               throws java.io.IOException

  Description copied from class: `XMLSerializer`
  print text data
  Overrides:
    `printXMLChar` in class `XMLSerializer`

### surrogates

    protected final void surrogates(int high,
                                    int low)
                             throws java.io.IOException

  Overrides:
    `surrogates` in class `BaseMarkupSerializer`

### printText

    protected void printText(java.lang.String text,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws java.io.IOException

  Overrides:
    `printText` in class `XMLSerializer`

### printText

    protected void printText(char[] chars,
                             int start,
                             int length,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws java.io.IOException

  Description copied from class: `BaseMarkupSerializer`
  Called to print additional text with whitespace handling. If spaces are preserved, the text is printed as if by calling `BaseMarkupSerializer.printText(String,boolean,boolean)` with a call to `Printer.breakLine()` for each new line. If spaces are not preserved, the text is broken at space boundaries if longer than the line width; Multiple spaces are printed as such, but spaces at beginning of line are removed.
  Overrides:
    `printText` in class `XMLSerializer`
  Following copied from class: `org.apache.xml.serialize.BaseMarkupSerializer`
  Parameters:
    `text` - The text to print
    `preserveSpace` - Space preserving flag
    `unescaped` - Print unescaped

### reset

    public boolean reset()

  Overrides:
    `reset` in class `XMLSerializer`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2004 Apache XML Project. All Rights Reserved.